package com.qgs.dc.mq.configuration;


import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Desc: "设备：00C 相关信息定义"
 * @Author: caixiang
 * @DATE: 2021/6/7 9:11
 */
@Configuration
public class ConfigOf00C {

    //水平扩展其他设备的时候 只要改 EQUIPMENT_NAME 就行了
    //1.现在MQConstant 上新增 EQUIPMENT_***; 2.然后复制 本class，然后EQUIPMENT_NAME = MQConstant.EQUIPMENT_***;就行了。
    public static final String EQUIPMENT_NAME_00C = "00C";

    public static final String EXCHANGE_NAME_00C = EQUIPMENT_NAME_00C +"_Exchange";
    public static final String EAP_REQUEST_QUEUE_00C = EQUIPMENT_NAME_00C +"_EAP_Request_Queue";
    public static final String EAP_RESPONSE_QUEUE_00C = EQUIPMENT_NAME_00C +"_EAP_Response_Queue";
    public static final String MES_REQUEST_QUEUE_00C = EQUIPMENT_NAME_00C +"_MES_Request_Queue";
    public static final String MES_RESPONSE_QUEUE_00C = EQUIPMENT_NAME_00C +"_MES_Response_Queue";
    public static final String EAP_REQUEST_QUEUE_ROUTINGKEY_00C = EQUIPMENT_NAME_00C +"_EAP_Request_Queue_RoutingKey";
    public static final String EAP_RESPONSE_QUEUE_ROUTINGKEY_00C = EQUIPMENT_NAME_00C +"_EAP_Response_Queue_RoutingKey";
    public static final String MES_REQUEST_QUEUE_ROUTINGKEY_00C = EQUIPMENT_NAME_00C +"_MES_Request_Queue_RoutingKey";
    public static final String MES_RESPONSE_QUEUE_ROUTINGKEY_00C = EQUIPMENT_NAME_00C +"_MES_Response_Queue_RoutingKey";


    @Bean
    public DirectExchange EXCHANGE_NAME_00C(){
        return new DirectExchange(EXCHANGE_NAME_00C);
    }

    //todo
    @Bean
    public Queue MES_REQUEST_QUEUE_00C(){
        Queue queue = new Queue(MES_REQUEST_QUEUE_00C);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }

    @Bean
    public Queue MES_RESPONSE_QUEUE_00C(){
        Queue queue = new Queue(MES_RESPONSE_QUEUE_00C);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }
    @Bean
    public Queue EAP_REQUEST_QUEUE_00C(){
        Queue queue = new Queue(EAP_REQUEST_QUEUE_00C);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;

    }
    @Bean
    public Queue EAP_RESPONSE_QUEUE_00C(){
        Queue queue = new Queue(EAP_RESPONSE_QUEUE_00C);
        queue.addArgument("x-dead-letter-exchange",ConfigOfDeadLetterQueue.EXCHANGE_NAME_DLE);
        queue.addArgument("x-dead-letter-routing-key",ConfigOfDeadLetterQueue.Dead_Letter_RoutingKey);
        //queue.addArgument("x-max-priority",ConfigOfDeadLetterQueue.MAX_PRIORITY);
        return queue;
    }
    

    @Bean
    public Binding bindExchangeAndQueueA_00C(){
        return BindingBuilder.bind(EAP_REQUEST_QUEUE_00C()).to(EXCHANGE_NAME_00C())
                .with(EAP_REQUEST_QUEUE_ROUTINGKEY_00C);
    }
    @Bean
    public Binding bindExchangeAndQueueB_00C(){
        return BindingBuilder.bind(EAP_RESPONSE_QUEUE_00C()).to(EXCHANGE_NAME_00C())
                .with(EAP_RESPONSE_QUEUE_ROUTINGKEY_00C);
    }

    @Bean
    public Binding bindExchangeAndQueueC_00C(){
        return BindingBuilder.bind(MES_REQUEST_QUEUE_00C()).to(EXCHANGE_NAME_00C())
                .with(MES_REQUEST_QUEUE_ROUTINGKEY_00C);
    }

    @Bean
    public Binding bindExchangeAndQueueD_00C(){
        return BindingBuilder.bind(MES_RESPONSE_QUEUE_00C()).to(EXCHANGE_NAME_00C())
                .with(MES_RESPONSE_QUEUE_ROUTINGKEY_00C);
    }
}